clear all
close all
tic

MkFig=0; % Set to 1 to generate JPEG figures, Set to 0 to plot the figures in MatLab
res='-r600';
Position=[0 0 1050 1250*1.0];
TitleSz=22; LblSz=24; AxSz=20;

Sfct=0:0.01:20; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

yy=2;

t0=(1e-3:1e-3:360)/360;
raw0=zeros(length(t0),((3*yy)+1));
raw0(:,1)=t0;

t=0:0.1:1; t=t';
raw=zeros(length(t),((3*yy)+1));
raw(:,1)=t;

RnFreqFct=[1 9];
RnMgFct=[1 1];

for ii=1:yy
    oo=((ii-1)*3)+(1:3)+1;
    Mag=RnMgFct(ii); F=(RnFreqFct(ii))*2*pi;
    for jj=1:3
        p=(jj-1)*(2*pi/3); %p=p+(pi/2);
        
        A0=Mag*cos((F*t0)+p);
        raw0(:,oo(jj))=A0';
        
        A=Mag*cos((F*t)+p);
        raw(:,oo(jj))=A';
    end
end

rr=yy*3; 
ct=length(Sfct);
ctT=length(t);

i=sqrt(-1);
R2=zeros(rr,1); R2fft=R2;
SpecFctParam=zeros(ct,rr); SpecFctParamFFT=SpecFctParam;
FtestParam=zeros(ctT,rr); FtestParamFFT=FtestParam; FtestParamMyIFFT=FtestParam; 
for oo=1:rr
    FF0=raw(:,oo+1);
    
    FFavg=mean(FF0);
    FFstd=max(FF0)-min(FF0);
    
    SpecFct=zeros(ct,1);
    for ii=2:ct
        display([num2str(ii) '/' num2str(ct) '   ' 9 num2str(oo) '/' num2str(rr)]);
        sinfct=sin(2*pi*t*(Sfct(ii)));
        cosfct=cos(2*pi*t*(Sfct(ii)));
        corrR=R2fct(cosfct,FF0);
        corrI=R2fct(sinfct,FF0);
        SpecFct(ii)=corrR+(i*corrI);
    end
    
    SpecFct=FFstd*SpecFct/(sum(abs(SpecFct)));
    SpecFct(1)=FFavg;
    SpecFctParam(:,oo)=SpecFct;

    Ftest=zeros(ctT,1);
    for ii=1:ct
        Ftest=((real(SpecFct(ii)))*cos(2*pi*t*Sfct(ii)))+Ftest;
        Ftest=((imag(SpecFct(ii)))*sin(2*pi*t*Sfct(ii)))+Ftest;
    end
    FtestParam(:,oo)=Ftest;
    R2(oo)=(R2fct(Ftest,FF0))^2;


    SpecFctFFT=myfft(FF0,Sfct); 
    
    SpecFctParamFFT(:,oo)=SpecFctFFT';

    Ftest=zeros(ctT,1);
    for ii=1:ct
        Ftest=((real(SpecFctFFT(ii)))*cos(2*pi*t*Sfct(ii)))+Ftest;
        Ftest=((imag(SpecFctFFT(ii)))*sin(2*pi*t*Sfct(ii)))+Ftest;
    end
    FtestParamFFT(:,oo)=Ftest;

    FtestMyIFFT=(myifft(t,Sfct,SpecFctFFT));
    FtestParamMyIFFT(:,oo)=FtestMyIFFT;
    R2fft(oo)=(R2fct(abs(Ftest),abs(FF0)))^2; %R2fft(oo)=(R2fct(Ftest,FF0))^2;

    aa=find((abs(SpecFctParam(2:end,oo)))==max(abs(SpecFctParam(2:end,oo)))); MaxF(oo)=Sfct(aa(end));

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if round(abs(MkFig))<2

ha=figure(1);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(t,raw(:,5),'o',t0,raw0(:,5),t0,raw0(:,2),'Linewidth',2); 
%legend('Low Res','f = 1','f = 9','Location','BestOutside')
xlabel('x','fontsize',LblSz,'fontweight','b'); 
ylabel('f(x)','fontsize',LblSz,'fontweight','b');
%title('CDFT','fontsize',LblSz,'fontweight','b');
if MkFig==1
    print(ha,'-djpeg','fig_1_9.jpeg',res)
    close all
end



ha=figure(2);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(Sfct(2:end),ct*abs(SpecFctParam(2:end,1)),'k.','Linewidth',2); 
%legend('Low Res','f = 1','f = 9','Location','BestOutside')
xlabel('f','fontsize',LblSz,'fontweight','b'); 
ylabel('magnitude','fontsize',LblSz,'fontweight','b');
title(['(a)' 10 'CDFT'],'fontsize',LblSz,'fontweight','b');
if MkFig==1
    print(ha,'-djpeg','fig_cft_S_abs.jpeg',res)
    close all
end


ha=figure(3);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(Sfct(2:end),angle(SpecFctParam(2:end,1)),'k.','Linewidth',2); 
%legend('Low Res','f = 1','f = 9','Location','BestOutside')
xlabel('f','fontsize',LblSz,'fontweight','b'); 
ylabel('radians ({\pi})','fontsize',LblSz,'fontweight','b');
title(['(b)' 10 'CDFT'],'fontsize',LblSz,'fontweight','b');
if MkFig==1
    print(ha,'-djpeg','fig_cft_S_phase.jpeg',res)
    close all
end


ha=figure(4);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(Sfct(2:end),abs(SpecFctParamFFT(2:end,1)),'k.','Linewidth',2); 
%legend('Low Res','f = 1','f = 9','Location','BestOutside')
xlabel('f','fontsize',LblSz,'fontweight','b'); 
ylabel('magnitude','fontsize',LblSz,'fontweight','b');
title(['(c)' 10 'NDFT'],'fontsize',LblSz,'fontweight','b');
if MkFig==1
    print(ha,'-djpeg','fig_fft_S_abs.jpeg',res)
    close all
end


ha=figure(5);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(Sfct(2:end),angle(SpecFctParamFFT(2:end,1))/pi,'k.','Linewidth',2); 
%legend('Low Res','f = 1','f = 9','Location','BestOutside')
xlabel('f','fontsize',LblSz,'fontweight','b'); 
ylabel('radians ({\pi})','fontsize',LblSz,'fontweight','b');
title(['(d)' 10 'NDFT'],'fontsize',LblSz,'fontweight','b');
if MkFig==1
    print(ha,'-djpeg','fig_fft_S_phase.jpeg',res)
    close all
end



ha=figure(6);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(t,FtestParam(:,1),'o',t0,raw0(:,2),'Linewidth',2); 
%legend('Low Res','f = 1','f = 9','Location','BestOutside')
xlabel('t','fontsize',LblSz,'fontweight','b'); 
ylabel('f(x)','fontsize',LblSz,'fontweight','b');
title('CDFT','fontsize',LblSz,'fontweight','b');
if MkFig==1
    print(ha,'-djpeg','fig_t_cfft.jpeg',res)
    close all
end


if MkFig==1

tt=10;
fig1a=imread('fig_cft_S_abs.jpeg');
fig1b=imread('fig_cft_S_phase.jpeg');
fig1c=imread('fig_fft_S_abs.jpeg');
fig1d=imread('fig_fft_S_phase.jpeg');

output1='fig_CompareS.jpeg';

[xx,yy,zz]=size(fig1a);

kk=(2*xx)+(3*tt);
verline=zeros(kk,tt,zz);
horline=zeros(tt,yy,zz);

figL=cat(1,horline,fig1a,horline,fig1c,horline);
figR=cat(1,horline,fig1b,horline,fig1d,horline);
figmerge=cat(2,verline,figL,verline,figR,verline);

%imshow(figmerge)
imwrite(figmerge,output1);
close all

end

end

runtime=toc;
